#include <assert.h>
#include <iostream.h>
#include "model.h"

model::model()
{
   my_dependents  = new view* [MAX_DEPENDENTS];
   num_dependents = 0;
}

void model::add_dependent(view* watcher)
{
   if (num_dependents < MAX_DEPENDENTS)
   {
      my_dependents[num_dependents] = watcher;
      num_dependents++;
   }
   else
      cerr << "I already have too many dependents!" << endl;
}

void model::change()
{
   for (int i = 0; i < num_dependents; i++)
       my_dependents[i]->update();
}
