(load "view.cl")

(defclass counter-box (view)
   ((box-character :accessor counter-box-character
                   :initarg  :character)
    (print-stream  :accessor counter-box-stream
                   :initarg  :stream)
   ))

(defmethod update ((receiver counter-box))
   (draw-line receiver)
   (format (counter-box-stream receiver) "~A" (counter-box-character receiver))
   (format (counter-box-stream receiver) "        ")
   (format (counter-box-stream receiver) "~A"
           (counter-value (view-model receiver)))
   (format (counter-box-stream receiver) "        ")
   (format (counter-box-stream receiver) "~A~%"
           (counter-box-character receiver))
   (draw-line receiver)
   )

(defmethod draw-line ((receiver counter-box))
   (do ((i 1 (+ i 1)))
       ((> i 20) nil)
     (format (counter-box-stream receiver) "~A"
             (counter-box-character receiver)))
   (format (counter-box-stream receiver) "~%")
   )
