(load "counter.cl")
(load "counter-box.cl")
(load "counter-line.cl")

(defun mvc-demo ()
   (setf model-one (make-instance 'counter))
   (setf view-one  (make-instance 'counter-box
                     :model model-one
                     :character "*"
                     :stream
                         (open (make-pathname :name "counter-box.out")
                               :direction :output :if-exists :supersede)))
   (setf view-two  (make-instance 'counter-line
                     :model model-one
                     :character "*"
                     :stream
                         (open (make-pathname :name "counter-line.out")
                               :direction :output :if-exists :supersede)))

   (add-dependent model-one view-one)
   (add-dependent model-one view-two)

   (do ((i 0 (+ i 1)))
       ((>= i 10) 'done)
     (cond ((or (= (rem i 2) 0) (= (rem i 3) 0))
               (increment model-one))
           ((= (rem i 7) 0)
               (reset model-one))
           (t  (decrement model-one))))
   )
