#ifndef MODEL_H_
#define MODEL_H_

class view;

#include "view.h"

const int MAX_DEPENDENTS = 10;

class model
{
   public:

            model         ();              // create and initialize
      void  add_dependent (view*);         // register a new observer
      virtual int value   () = 0;

   protected:

      virtual void change ();             // a model sends itself this message
                                          // whenever one of its data changes
   private:

      view* * my_dependents;              // array of view*s
      int     num_dependents;
};

#endif
