import java.io.*;

public class CounterLineView extends View
{
   public CounterLineView (Model  whatIWatch,
                           String lineCharacter,
                           String fileName)
   {
      super( whatIWatch );

      myLineCharacter = lineCharacter;

      try
      {
         myPrintStream   = new PrintStream( new FileOutputStream( fileName ) );
      }
      catch (IOException e)
      {
         System.out.println( e );
      }
   }

   public void update ()
   {
      myPrintStream.print( "The count's value is " );
      drawWrapper( 3 );
      myPrintStream.print(  " " + getModel().value() + " " );
      drawWrapper( 3 );

      myPrintStream.println();
      myPrintStream.println();
      myPrintStream.println();
   }

   private String      myLineCharacter;
   private PrintStream myPrintStream;

   private void drawWrapper(int numberOfCharacters)
   {
      int i;
      for (i = 0; i < numberOfCharacters; i++)
          myPrintStream.print( myLineCharacter );
   }
}
