import java.util.Vector;

public abstract class Model
{
   public Model ()
   {
      myDependents = new Vector();
   }

   public void addDependent( View newDependent )
   {
         myDependents.addElement( newDependent );
   }

   public abstract int value ();

   protected void change ()
   {
      View aDependent;

      for (int i = 0; i < myDependents.size(); i++)
      {
         aDependent = (View) myDependents.elementAt(i);
         aDependent.update();
      }
   }

   private Vector myDependents;
}
